/* capability.c generated by valac 0.32.1, the Vala compiler
 * generated from capability.vala, do not modify */

/*
 * Copyright (c) 2016 gnome-pomodoro contributors
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 *
 * Authors: Kamil Prusko <kamilprusko@gmail.com>
 *
 */

#include <glib.h>
#include <glib-object.h>
#include <stdlib.h>
#include <string.h>


#define POMODORO_TYPE_CAPABILITY (pomodoro_capability_get_type ())
#define POMODORO_CAPABILITY(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), POMODORO_TYPE_CAPABILITY, PomodoroCapability))
#define POMODORO_CAPABILITY_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), POMODORO_TYPE_CAPABILITY, PomodoroCapabilityClass))
#define POMODORO_IS_CAPABILITY(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), POMODORO_TYPE_CAPABILITY))
#define POMODORO_IS_CAPABILITY_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), POMODORO_TYPE_CAPABILITY))
#define POMODORO_CAPABILITY_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), POMODORO_TYPE_CAPABILITY, PomodoroCapabilityClass))

typedef struct _PomodoroCapability PomodoroCapability;
typedef struct _PomodoroCapabilityClass PomodoroCapabilityClass;
typedef struct _PomodoroCapabilityPrivate PomodoroCapabilityPrivate;
#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))

#define POMODORO_TYPE_VIRTUAL_CAPABILITY (pomodoro_virtual_capability_get_type ())
#define POMODORO_VIRTUAL_CAPABILITY(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), POMODORO_TYPE_VIRTUAL_CAPABILITY, PomodoroVirtualCapability))
#define POMODORO_VIRTUAL_CAPABILITY_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), POMODORO_TYPE_VIRTUAL_CAPABILITY, PomodoroVirtualCapabilityClass))
#define POMODORO_IS_VIRTUAL_CAPABILITY(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), POMODORO_TYPE_VIRTUAL_CAPABILITY))
#define POMODORO_IS_VIRTUAL_CAPABILITY_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), POMODORO_TYPE_VIRTUAL_CAPABILITY))
#define POMODORO_VIRTUAL_CAPABILITY_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), POMODORO_TYPE_VIRTUAL_CAPABILITY, PomodoroVirtualCapabilityClass))

typedef struct _PomodoroVirtualCapability PomodoroVirtualCapability;
typedef struct _PomodoroVirtualCapabilityClass PomodoroVirtualCapabilityClass;
typedef struct _PomodoroVirtualCapabilityPrivate PomodoroVirtualCapabilityPrivate;
#define _vala_assert(expr, msg) if G_LIKELY (expr) ; else g_assertion_message_expr (G_LOG_DOMAIN, __FILE__, __LINE__, G_STRFUNC, msg);
#define _vala_return_if_fail(expr, msg) if G_LIKELY (expr) ; else { g_return_if_fail_warning (G_LOG_DOMAIN, G_STRFUNC, msg); return; }
#define _vala_return_val_if_fail(expr, msg, val) if G_LIKELY (expr) ; else { g_return_if_fail_warning (G_LOG_DOMAIN, G_STRFUNC, msg); return val; }
#define _vala_warn_if_fail(expr, msg) if G_LIKELY (expr) ; else g_warn_message (G_LOG_DOMAIN, __FILE__, __LINE__, G_STRFUNC, msg);

struct _PomodoroCapability {
	GInitiallyUnowned parent_instance;
	PomodoroCapabilityPrivate * priv;
};

struct _PomodoroCapabilityClass {
	GInitiallyUnownedClass parent_class;
};

struct _PomodoroCapabilityPrivate {
	gchar* _name;
	PomodoroCapability* _fallback;
	gboolean _enabled_request;
	gint inhibit_count;
	GBinding* enabled_binding;
};

struct _PomodoroVirtualCapability {
	PomodoroCapability parent_instance;
	PomodoroVirtualCapabilityPrivate * priv;
};

struct _PomodoroVirtualCapabilityClass {
	PomodoroCapabilityClass parent_class;
};


static gpointer pomodoro_capability_parent_class = NULL;
static gpointer pomodoro_virtual_capability_parent_class = NULL;

GType pomodoro_capability_get_type (void) G_GNUC_CONST;
#define POMODORO_CAPABILITY_GET_PRIVATE(o) (G_TYPE_INSTANCE_GET_PRIVATE ((o), POMODORO_TYPE_CAPABILITY, PomodoroCapabilityPrivate))
enum  {
	POMODORO_CAPABILITY_DUMMY_PROPERTY,
	POMODORO_CAPABILITY_NAME,
	POMODORO_CAPABILITY_ENABLED,
	POMODORO_CAPABILITY_ENABLED_REQUEST,
	POMODORO_CAPABILITY_FALLBACK
};
PomodoroCapability* pomodoro_capability_new (const gchar* name, gboolean enabled);
PomodoroCapability* pomodoro_capability_construct (GType object_type, const gchar* name, gboolean enabled);
void pomodoro_capability_set_name (PomodoroCapability* self, const gchar* value);
void pomodoro_capability_set_enabled_request (PomodoroCapability* self, gboolean value);
PomodoroCapability* pomodoro_capability_new_with_fallback (PomodoroCapability* fallback, gboolean enabled);
PomodoroCapability* pomodoro_capability_construct_with_fallback (GType object_type, PomodoroCapability* fallback, gboolean enabled);
const gchar* pomodoro_capability_get_name (PomodoroCapability* self);
void pomodoro_capability_set_fallback (PomodoroCapability* self, PomodoroCapability* value);
gboolean pomodoro_capability_is_virtual (PomodoroCapability* self);
GType pomodoro_virtual_capability_get_type (void) G_GNUC_CONST;
gboolean pomodoro_capability_is_inhibited (PomodoroCapability* self);
static void pomodoro_capability_real_dispose (GObject* base);
PomodoroCapability* pomodoro_capability_get_fallback (PomodoroCapability* self);
void pomodoro_capability_uninhibit (PomodoroCapability* self);
gboolean pomodoro_capability_enable (PomodoroCapability* self);
gboolean pomodoro_capability_get_enabled (PomodoroCapability* self);
gboolean pomodoro_capability_disable (PomodoroCapability* self);
void pomodoro_capability_inhibit (PomodoroCapability* self);
gboolean pomodoro_capability_get_enabled_request (PomodoroCapability* self);
static void pomodoro_capability_finalize (GObject* obj);
static void _vala_pomodoro_capability_get_property (GObject * object, guint property_id, GValue * value, GParamSpec * pspec);
static void _vala_pomodoro_capability_set_property (GObject * object, guint property_id, const GValue * value, GParamSpec * pspec);
enum  {
	POMODORO_VIRTUAL_CAPABILITY_DUMMY_PROPERTY
};
PomodoroVirtualCapability* pomodoro_virtual_capability_new (const gchar* name, gboolean enabled);
PomodoroVirtualCapability* pomodoro_virtual_capability_construct (GType object_type, const gchar* name, gboolean enabled);
PomodoroVirtualCapability* pomodoro_virtual_capability_new_with_fallback (PomodoroCapability* fallback, gboolean enabled);
PomodoroVirtualCapability* pomodoro_virtual_capability_construct_with_fallback (GType object_type, PomodoroCapability* fallback, gboolean enabled);


PomodoroCapability* pomodoro_capability_construct (GType object_type, const gchar* name, gboolean enabled) {
	PomodoroCapability * self = NULL;
	const gchar* _tmp0_ = NULL;
	gboolean _tmp1_ = FALSE;
	g_return_val_if_fail (name != NULL, NULL);
	self = (PomodoroCapability*) g_object_new (object_type, NULL);
	_tmp0_ = name;
	pomodoro_capability_set_name (self, _tmp0_);
	_tmp1_ = enabled;
	pomodoro_capability_set_enabled_request (self, _tmp1_);
	return self;
}


PomodoroCapability* pomodoro_capability_new (const gchar* name, gboolean enabled) {
	return pomodoro_capability_construct (POMODORO_TYPE_CAPABILITY, name, enabled);
}


PomodoroCapability* pomodoro_capability_construct_with_fallback (GType object_type, PomodoroCapability* fallback, gboolean enabled) {
	PomodoroCapability * self = NULL;
	PomodoroCapability* _tmp0_ = NULL;
	const gchar* _tmp1_ = NULL;
	gboolean _tmp2_ = FALSE;
	PomodoroCapability* _tmp3_ = NULL;
	g_return_val_if_fail (fallback != NULL, NULL);
	self = (PomodoroCapability*) g_object_new (object_type, NULL);
	_tmp0_ = fallback;
	_tmp1_ = _tmp0_->priv->_name;
	pomodoro_capability_set_name (self, _tmp1_);
	_tmp2_ = enabled;
	pomodoro_capability_set_enabled_request (self, _tmp2_);
	_tmp3_ = fallback;
	pomodoro_capability_set_fallback (self, _tmp3_);
	return self;
}


PomodoroCapability* pomodoro_capability_new_with_fallback (PomodoroCapability* fallback, gboolean enabled) {
	return pomodoro_capability_construct_with_fallback (POMODORO_TYPE_CAPABILITY, fallback, enabled);
}


gboolean pomodoro_capability_is_virtual (PomodoroCapability* self) {
	gboolean result = FALSE;
	g_return_val_if_fail (self != NULL, FALSE);
	result = G_TYPE_CHECK_INSTANCE_TYPE (self, POMODORO_TYPE_VIRTUAL_CAPABILITY);
	return result;
}


gboolean pomodoro_capability_is_inhibited (PomodoroCapability* self) {
	gboolean result = FALSE;
	gint _tmp0_ = 0;
	g_return_val_if_fail (self != NULL, FALSE);
	_tmp0_ = self->priv->inhibit_count;
	result = _tmp0_ > 0;
	return result;
}


static gpointer _g_object_ref0 (gpointer self) {
	return self ? g_object_ref (self) : NULL;
}


static void pomodoro_capability_real_dispose (GObject* base) {
	PomodoroCapability * self;
	GBinding* _tmp0_ = NULL;
	gboolean _tmp3_ = FALSE;
	PomodoroCapability* _tmp4_ = NULL;
	PomodoroCapability* _tmp5_ = NULL;
	self = (PomodoroCapability*) base;
	_tmp0_ = self->priv->enabled_binding;
	if (_tmp0_ != NULL) {
		GBinding* _tmp1_ = NULL;
		GBinding* _tmp2_ = NULL;
		_tmp1_ = self->priv->enabled_binding;
		_tmp2_ = _g_object_ref0 (_tmp1_);
		g_binding_unbind (_tmp2_);
	}
	_tmp4_ = pomodoro_capability_get_fallback (self);
	_tmp5_ = _tmp4_;
	if (_tmp5_ != NULL) {
		gboolean _tmp6_ = FALSE;
		_tmp6_ = pomodoro_capability_is_virtual (self);
		_tmp3_ = !_tmp6_;
	} else {
		_tmp3_ = FALSE;
	}
	if (_tmp3_) {
		PomodoroCapability* _tmp7_ = NULL;
		PomodoroCapability* _tmp8_ = NULL;
		_tmp7_ = pomodoro_capability_get_fallback (self);
		_tmp8_ = _tmp7_;
		pomodoro_capability_uninhibit (_tmp8_);
	}
	G_OBJECT_CLASS (pomodoro_capability_parent_class)->dispose ((GObject*) G_TYPE_CHECK_INSTANCE_CAST (self, G_TYPE_INITIALLY_UNOWNED, GInitiallyUnowned));
}


gboolean pomodoro_capability_enable (PomodoroCapability* self) {
	gboolean result = FALSE;
	gboolean _tmp0_ = FALSE;
	gboolean _tmp1_ = FALSE;
	g_return_val_if_fail (self != NULL, FALSE);
	pomodoro_capability_set_enabled_request (self, TRUE);
	_tmp0_ = pomodoro_capability_get_enabled (self);
	_tmp1_ = _tmp0_;
	result = _tmp1_ == TRUE;
	return result;
}


gboolean pomodoro_capability_disable (PomodoroCapability* self) {
	gboolean result = FALSE;
	gboolean _tmp0_ = FALSE;
	gboolean _tmp1_ = FALSE;
	g_return_val_if_fail (self != NULL, FALSE);
	pomodoro_capability_set_enabled_request (self, FALSE);
	_tmp0_ = pomodoro_capability_get_enabled (self);
	_tmp1_ = _tmp0_;
	result = _tmp1_ == FALSE;
	return result;
}


void pomodoro_capability_inhibit (PomodoroCapability* self) {
	gint _tmp0_ = 0;
	gint _tmp1_ = 0;
	g_return_if_fail (self != NULL);
	_tmp0_ = self->priv->inhibit_count;
	self->priv->inhibit_count = _tmp0_ + 1;
	_tmp1_ = self->priv->inhibit_count;
	if (_tmp1_ == 1) {
		g_object_notify ((GObject*) self, "enabled");
	}
}


void pomodoro_capability_uninhibit (PomodoroCapability* self) {
	gint _tmp0_ = 0;
	gint _tmp1_ = 0;
	g_return_if_fail (self != NULL);
	_tmp0_ = self->priv->inhibit_count;
	self->priv->inhibit_count = _tmp0_ - 1;
	_tmp1_ = self->priv->inhibit_count;
	if (_tmp1_ == 0) {
		g_object_notify ((GObject*) self, "enabled");
	}
}


const gchar* pomodoro_capability_get_name (PomodoroCapability* self) {
	const gchar* result;
	const gchar* _tmp0_ = NULL;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->_name;
	result = _tmp0_;
	return result;
}


void pomodoro_capability_set_name (PomodoroCapability* self, const gchar* value) {
	const gchar* _tmp0_ = NULL;
	gchar* _tmp1_ = NULL;
	g_return_if_fail (self != NULL);
	_tmp0_ = value;
	_tmp1_ = g_strdup (_tmp0_);
	_g_free0 (self->priv->_name);
	self->priv->_name = _tmp1_;
	g_object_notify ((GObject *) self, "name");
}


gboolean pomodoro_capability_get_enabled (PomodoroCapability* self) {
	gboolean result;
	gboolean _tmp0_ = FALSE;
	gboolean _tmp1_ = FALSE;
	g_return_val_if_fail (self != NULL, FALSE);
	_tmp1_ = pomodoro_capability_is_inhibited (self);
	if (_tmp1_) {
		_tmp0_ = FALSE;
	} else {
		gboolean _tmp2_ = FALSE;
		gboolean _tmp3_ = FALSE;
		_tmp2_ = pomodoro_capability_get_enabled_request (self);
		_tmp3_ = _tmp2_;
		_tmp0_ = _tmp3_;
	}
	result = _tmp0_;
	return result;
}


gboolean pomodoro_capability_get_enabled_request (PomodoroCapability* self) {
	gboolean result;
	gboolean _tmp0_ = FALSE;
	g_return_val_if_fail (self != NULL, FALSE);
	_tmp0_ = self->priv->_enabled_request;
	result = _tmp0_;
	return result;
}


void pomodoro_capability_set_enabled_request (PomodoroCapability* self, gboolean value) {
	gboolean _tmp0_ = FALSE;
	gboolean _tmp1_ = FALSE;
	g_return_if_fail (self != NULL);
	_tmp0_ = self->priv->_enabled_request;
	_tmp1_ = value;
	if (_tmp0_ != _tmp1_) {
		gboolean _tmp2_ = FALSE;
		gboolean _tmp3_ = FALSE;
		_tmp2_ = value;
		self->priv->_enabled_request = _tmp2_;
		g_object_notify ((GObject*) self, "enabled-request");
		_tmp3_ = pomodoro_capability_is_inhibited (self);
		if (!_tmp3_) {
			g_object_notify ((GObject*) self, "enabled");
		}
	}
}


PomodoroCapability* pomodoro_capability_get_fallback (PomodoroCapability* self) {
	PomodoroCapability* result;
	PomodoroCapability* _tmp0_ = NULL;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->_fallback;
	result = _tmp0_;
	return result;
}


void pomodoro_capability_set_fallback (PomodoroCapability* self, PomodoroCapability* value) {
	PomodoroCapability* new_fallback = NULL;
	PomodoroCapability* _tmp0_ = NULL;
	PomodoroCapability* _tmp1_ = NULL;
	PomodoroCapability* _tmp2_ = NULL;
	PomodoroCapability* _tmp3_ = NULL;
	g_return_if_fail (self != NULL);
	_tmp0_ = value;
	_tmp1_ = _g_object_ref0 (_tmp0_);
	new_fallback = _tmp1_;
	_tmp2_ = self->priv->_fallback;
	_tmp3_ = new_fallback;
	if (_tmp2_ != _tmp3_) {
		GBinding* _tmp4_ = NULL;
		PomodoroCapability* _tmp7_ = NULL;
		gboolean _tmp13_ = FALSE;
		PomodoroCapability* _tmp14_ = NULL;
		PomodoroCapability* _tmp17_ = NULL;
		PomodoroCapability* _tmp18_ = NULL;
		_tmp4_ = self->priv->enabled_binding;
		if (_tmp4_ != NULL) {
			GBinding* _tmp5_ = NULL;
			GBinding* _tmp6_ = NULL;
			_tmp5_ = self->priv->enabled_binding;
			_tmp6_ = _g_object_ref0 (_tmp5_);
			g_binding_unbind (_tmp6_);
		}
		_tmp7_ = new_fallback;
		if (_tmp7_ != NULL) {
			gboolean _tmp8_ = FALSE;
			_tmp8_ = pomodoro_capability_is_virtual (self);
			if (_tmp8_) {
				PomodoroCapability* _tmp9_ = NULL;
				GBinding* _tmp10_ = NULL;
				GBinding* _tmp11_ = NULL;
				_tmp9_ = new_fallback;
				_tmp10_ = g_object_bind_property_with_closures ((GObject*) self, "enabled-request", (GObject*) _tmp9_, "enabled-request", G_BINDING_SYNC_CREATE | G_BINDING_BIDIRECTIONAL, (GClosure*) ((NULL == NULL) ? NULL : g_cclosure_new ((GCallback) NULL, NULL, NULL)), (GClosure*) ((NULL == NULL) ? NULL : g_cclosure_new ((GCallback) NULL, NULL, NULL)));
				_tmp11_ = _g_object_ref0 (_tmp10_);
				_g_object_unref0 (self->priv->enabled_binding);
				self->priv->enabled_binding = _tmp11_;
			} else {
				PomodoroCapability* _tmp12_ = NULL;
				_tmp12_ = new_fallback;
				pomodoro_capability_inhibit (_tmp12_);
			}
		}
		_tmp14_ = self->priv->_fallback;
		if (_tmp14_ != NULL) {
			gboolean _tmp15_ = FALSE;
			_tmp15_ = pomodoro_capability_is_virtual (self);
			_tmp13_ = !_tmp15_;
		} else {
			_tmp13_ = FALSE;
		}
		if (_tmp13_) {
			PomodoroCapability* _tmp16_ = NULL;
			_tmp16_ = self->priv->_fallback;
			pomodoro_capability_uninhibit (_tmp16_);
		}
		_tmp17_ = new_fallback;
		_tmp18_ = _g_object_ref0 (_tmp17_);
		_g_object_unref0 (self->priv->_fallback);
		self->priv->_fallback = _tmp18_;
		g_object_notify ((GObject*) self, "fallback");
	}
	_g_object_unref0 (new_fallback);
}


static void pomodoro_capability_class_init (PomodoroCapabilityClass * klass) {
	pomodoro_capability_parent_class = g_type_class_peek_parent (klass);
	g_type_class_add_private (klass, sizeof (PomodoroCapabilityPrivate));
	((GObjectClass *) klass)->dispose = pomodoro_capability_real_dispose;
	G_OBJECT_CLASS (klass)->get_property = _vala_pomodoro_capability_get_property;
	G_OBJECT_CLASS (klass)->set_property = _vala_pomodoro_capability_set_property;
	G_OBJECT_CLASS (klass)->finalize = pomodoro_capability_finalize;
	g_object_class_install_property (G_OBJECT_CLASS (klass), POMODORO_CAPABILITY_NAME, g_param_spec_string ("name", "name", "name", NULL, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE | G_PARAM_WRITABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), POMODORO_CAPABILITY_ENABLED, g_param_spec_boolean ("enabled", "enabled", "enabled", FALSE, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), POMODORO_CAPABILITY_ENABLED_REQUEST, g_param_spec_boolean ("enabled-request", "enabled-request", "enabled-request", FALSE, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE | G_PARAM_WRITABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), POMODORO_CAPABILITY_FALLBACK, g_param_spec_object ("fallback", "fallback", "fallback", POMODORO_TYPE_CAPABILITY, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE | G_PARAM_WRITABLE));
}


static void pomodoro_capability_instance_init (PomodoroCapability * self) {
	self->priv = POMODORO_CAPABILITY_GET_PRIVATE (self);
	self->priv->inhibit_count = 0;
}


static void pomodoro_capability_finalize (GObject* obj) {
	PomodoroCapability * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, POMODORO_TYPE_CAPABILITY, PomodoroCapability);
	_g_free0 (self->priv->_name);
	_g_object_unref0 (self->priv->_fallback);
	_g_object_unref0 (self->priv->enabled_binding);
	G_OBJECT_CLASS (pomodoro_capability_parent_class)->finalize (obj);
}


GType pomodoro_capability_get_type (void) {
	static volatile gsize pomodoro_capability_type_id__volatile = 0;
	if (g_once_init_enter (&pomodoro_capability_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (PomodoroCapabilityClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) pomodoro_capability_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (PomodoroCapability), 0, (GInstanceInitFunc) pomodoro_capability_instance_init, NULL };
		GType pomodoro_capability_type_id;
		pomodoro_capability_type_id = g_type_register_static (G_TYPE_INITIALLY_UNOWNED, "PomodoroCapability", &g_define_type_info, 0);
		g_once_init_leave (&pomodoro_capability_type_id__volatile, pomodoro_capability_type_id);
	}
	return pomodoro_capability_type_id__volatile;
}


static void _vala_pomodoro_capability_get_property (GObject * object, guint property_id, GValue * value, GParamSpec * pspec) {
	PomodoroCapability * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, POMODORO_TYPE_CAPABILITY, PomodoroCapability);
	switch (property_id) {
		case POMODORO_CAPABILITY_NAME:
		g_value_set_string (value, pomodoro_capability_get_name (self));
		break;
		case POMODORO_CAPABILITY_ENABLED:
		g_value_set_boolean (value, pomodoro_capability_get_enabled (self));
		break;
		case POMODORO_CAPABILITY_ENABLED_REQUEST:
		g_value_set_boolean (value, pomodoro_capability_get_enabled_request (self));
		break;
		case POMODORO_CAPABILITY_FALLBACK:
		g_value_set_object (value, pomodoro_capability_get_fallback (self));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}


static void _vala_pomodoro_capability_set_property (GObject * object, guint property_id, const GValue * value, GParamSpec * pspec) {
	PomodoroCapability * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, POMODORO_TYPE_CAPABILITY, PomodoroCapability);
	switch (property_id) {
		case POMODORO_CAPABILITY_NAME:
		pomodoro_capability_set_name (self, g_value_get_string (value));
		break;
		case POMODORO_CAPABILITY_ENABLED_REQUEST:
		pomodoro_capability_set_enabled_request (self, g_value_get_boolean (value));
		break;
		case POMODORO_CAPABILITY_FALLBACK:
		pomodoro_capability_set_fallback (self, g_value_get_object (value));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}


PomodoroVirtualCapability* pomodoro_virtual_capability_construct (GType object_type, const gchar* name, gboolean enabled) {
	PomodoroVirtualCapability * self = NULL;
	const gchar* _tmp0_ = NULL;
	gboolean _tmp1_ = FALSE;
	g_return_val_if_fail (name != NULL, NULL);
	_tmp0_ = name;
	_tmp1_ = enabled;
	self = (PomodoroVirtualCapability*) pomodoro_capability_construct (object_type, _tmp0_, _tmp1_);
	return self;
}


PomodoroVirtualCapability* pomodoro_virtual_capability_new (const gchar* name, gboolean enabled) {
	return pomodoro_virtual_capability_construct (POMODORO_TYPE_VIRTUAL_CAPABILITY, name, enabled);
}


PomodoroVirtualCapability* pomodoro_virtual_capability_construct_with_fallback (GType object_type, PomodoroCapability* fallback, gboolean enabled) {
	PomodoroVirtualCapability * self = NULL;
	PomodoroCapability* _tmp0_ = NULL;
	PomodoroCapability* _tmp1_ = NULL;
	gboolean _tmp2_ = FALSE;
	g_return_val_if_fail (fallback != NULL, NULL);
	_tmp0_ = fallback;
	_vala_assert (_tmp0_ != NULL, "fallback != null");
	_tmp1_ = fallback;
	_tmp2_ = enabled;
	self = (PomodoroVirtualCapability*) pomodoro_capability_construct_with_fallback (object_type, _tmp1_, _tmp2_);
	return self;
}


PomodoroVirtualCapability* pomodoro_virtual_capability_new_with_fallback (PomodoroCapability* fallback, gboolean enabled) {
	return pomodoro_virtual_capability_construct_with_fallback (POMODORO_TYPE_VIRTUAL_CAPABILITY, fallback, enabled);
}


static void pomodoro_virtual_capability_class_init (PomodoroVirtualCapabilityClass * klass) {
	pomodoro_virtual_capability_parent_class = g_type_class_peek_parent (klass);
}


static void pomodoro_virtual_capability_instance_init (PomodoroVirtualCapability * self) {
}


GType pomodoro_virtual_capability_get_type (void) {
	static volatile gsize pomodoro_virtual_capability_type_id__volatile = 0;
	if (g_once_init_enter (&pomodoro_virtual_capability_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (PomodoroVirtualCapabilityClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) pomodoro_virtual_capability_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (PomodoroVirtualCapability), 0, (GInstanceInitFunc) pomodoro_virtual_capability_instance_init, NULL };
		GType pomodoro_virtual_capability_type_id;
		pomodoro_virtual_capability_type_id = g_type_register_static (POMODORO_TYPE_CAPABILITY, "PomodoroVirtualCapability", &g_define_type_info, 0);
		g_once_init_leave (&pomodoro_virtual_capability_type_id__volatile, pomodoro_virtual_capability_type_id);
	}
	return pomodoro_virtual_capability_type_id__volatile;
}



